package com.gic.cloud.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.cloud.service.IndexApiService;
import com.gic.cloud.web.qo.DateTypeQo;
import com.gic.cloud.web.vo.index.IndexSalesVo;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.data.api.dto.IndexSalesDTO;
import com.gic.data.api.service.IndexSalesApiService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
public class IndexController {
    @Autowired
    private IndexSalesApiService indexSalesApiService;
    @Autowired
    private StoreSearchUtils storeSearchUtils;

    @RequestMapping("index-mbr")
    public RestResponse indexMbr(Integer enterpriseId, Integer userId){

    }

    @RequestMapping("index-sales")
    public RestResponse indexSales(Integer userId, Integer enterpriseId, String searchJSON,
                                   DateTypeQo dateTypeQo, String mbrAreaId, Integer dataType){
        List<Integer> list = this.storeSearchUtils.storeSearch(userId, enterpriseId, searchJSON);
        List<String> onLine = this.storeSearchUtils.onLineStoreSearch(userId, enterpriseId, searchJSON);
        ServiceResponse<IndexSalesDTO> indexSales = this.indexSalesApiService.getIndexSales(enterpriseId, list, onLine,
                StringUtils.isNoneBlank(mbrAreaId) ? Long.valueOf(mbrAreaId) : null, dateTypeQo.getType(), dateTypeQo.getDate(), dataType);
        return RestResponse.success(EntityUtil.changeEntityByJSON(IndexSalesVo.class, indexSales.getResult()));
    }
}
